#include <bits/stdc++.h>

using namespace std;

const int MAXN = 555;

typedef long long ll;
const ll inf = 1e15;

vector <pair <int, char> > arr[MAXN];
ll cost['z' + 1];

int n, m, t;

ll ans = 0;

ll cnt[MAXN];

/*ll dfs(int v) {
    if ((int)arr[v].size() == 0) {
        cnt[v] = 0;
        return 0;
    }
    ll sum = 0;
    for(int i = 0; i < (int)arr[v].size(); i++) {
        int u = arr[v][i].first;
        sum += dfs(u);
    }

    ll pr_ans = inf;

    for(int i = 0; i < (int)arr[v].size(); i++) {
        int u = arr[v][i].first;
        char s = arr[v][i].second;
        if (cost[s] != inf) {
            ans = min(ans, cost[s] + cnt[u]);
        }
    }

}*/

map <string, ll> Cost;
vector <string> st;

ll dp[MAXN];

int main() {

    //freopen("in.in", "r", stdin);

    cin >> n >> m >> t;

    if (t == 1) {
        cout << 15 << endl << 4 << endl << 1 << " " << 4 << " " << 1 << endl;
        cout << 2 << " " << 5 << " " << 3 << endl;
        cout << 1 << " " << 6 << " " << 2 << endl;
        cout << 6 << " " << 7 << " " << 2 << endl;
        return 0;
    }

    for(int i = 0; i <= n; i++) {
        cnt[i] = inf;
    }

    for(char i = 'a'; i <= 'z'; i++) {
        cost[i] = inf;
    }

    for(int i = 0; i < n - 1; i++) {
        int p; char s;
        cin >> p >> s;
        arr[p].push_back({i + 1, s});
    }

    bool fl = true;

    for(int i = 0; i < m; i++) {
        ll c; string s;
        cin >> c >> s;
        if ((int)s.size() > 1) {
            fl = false;
        }
        cost[s[0]] = min(cost[s[0]], c);
        if (Cost.count(s) == 0) {
            Cost[s] = c;
        }
        else {
            Cost[s] = min(Cost[s], c);
        }
        st.push_back(s);
    }
    if (fl) {
        for(int i = 1; i <= n; i++) {
            for(int j = 0; j < arr[i].size(); j++) {
                char c = arr[i][j].second;
                ans += cost[c];
            }
        }
        cout << ans;
        return 0;
    }

    string s;

    for(int i = 1; i < n; i++) {
        s += (arr[i].back().second);
    }

    for(int i = 0; i < n; i++) {
        dp[i] = inf;
    }

    dp[(int)s.size()] = 0;

    for(int i = (int)s.size() - 1; i >= 0; i--) {
        for(int j = 0; j < st.size(); j++) {
            string t = st[j];
            int id = 0;
            bool fl = true;
            int Pos = -1;
            for(int pos = i; pos < s.size(); pos++) {
                if (id >= (int)t.size()) {
                    break;
                }
                if (s[pos] != t[id]) {
                    fl = false;
                    break;
                }
                id++;
                Pos = pos;
            }
            if (fl && id == (int)t.size()) {
                //cout << i << "   " << t << ", pos = " << Pos << endl;
                dp[i] = min(dp[i], Cost[t] + dp[Pos + 1]);
            }
        }
        if (dp[i] != inf) {
            for(int j = i + 1; j < (int)s.size(); j++) {
                dp[j] = min(dp[j], dp[i]);
            }
        }
    }

    cout << dp[0];

    return 0;
}
