#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = 1e5 + 10;

ll n, m;

vector <int> arr[MAXN];

ll len_path[MAXN];

ll cnt_l = 0;

ll dfs(int v) {
    if (arr[v].size() == 0) {
        len_path[v] = 1LL;
        cnt_l++;
        return 1LL;
    }
    ll mx1 = 0, mx2 = 0;
    for(int i = 0; i < (int)arr[v].size(); i++) {
        int u = arr[v][i];
        dfs(u);
        if (mx1 < len_path[u]) {
            mx2 = mx1;
            mx1 = len_path[u];
        }
        else {
            if (mx2 < len_path[u]) {
                mx2 = len_path[u];
            }
        }
    }
    len_path[v] = mx1 + 1;
    //cout << v << ", " << len_path[v] << endl;
    return mx1 + mx2 + 1;
}

int main() {

    //freopen("in.in", "r", stdin);

    cin >> n >> m;

    for(int i = 2; i <= n; i++) {
        int p; cin >> p;
        arr[p].push_back(i);
    }

    ll l1 = dfs(1);

    if (cnt_l > 2) {
        cnt_l = 2LL;
    }

    //cout << l1 << endl;

    cout << l1 + (m - 1)*len_path[1]*cnt_l;

    return 0;
}
